package beautiful01.validator;

import java.util.ArrayList;
import java.util.List;

public class ColumnValidator {
	private String columnName;
	private List<IValidator> validators = new ArrayList<IValidator>();
	public ColumnValidator(String columnName) {
		this.columnName = columnName;
	}
	public ColumnValidator(String columnName, IValidator... validators) {
		this(columnName);
		for (IValidator v : validators) {
			add(v);
		}
	}
	public String getColumnName() {
		return columnName;
	}
	public void add(IValidator validator) {
		validators.add(validator);
	}
	public void validate(String value) {
		for (IValidator v : validators) {
			String error = v.valid(columnName, value);
			if (error != null) {
				throw new ValidException(error);
			}
		}
	}
}