package beautiful02.ex1;

import org.apache.commons.lang.StringUtils;
import org.seasar.extension.dataset.DataRow;
import org.seasar.extension.dataset.DataTable;

import beautiful01.validator.ColumnValidator;
import beautiful01.validator.DataRowValidator;
import beautiful01.validator.MaxLengthValidator;
import beautiful01.validator.NotEmptyCondition;
import beautiful01.validator.NumberValidator;
import beautiful01.validator.RequiredValidator;
import beautiful02.dao.CategoryDao;
import beautiful02.entity.Category;

/**
 * JeS[}X^̃C|[g
 */
public class CategoryImportLogicImpl {
	/** sԍ̃ItZbglif[^͂QsڂJn邽߁j */
	public static final int LINE_NUM_OFFSET = 2;
	/** JeS[Dao */
	private CategoryDao categoryDao;
	/** ͌؏NX */
	private DataRowValidator validator = new DataRowValidator();

	/**
	 * RXgN^
	 */
	public CategoryImportLogicImpl() {
		initialize();
	}

	/**
	 * F͌؂̃[ݒ 
	 */
	private void initialize() {
		ColumnValidator colId = new ColumnValidator("id");
		colId.add(new NotEmptyCondition(new NumberValidator()));

		ColumnValidator colName = new ColumnValidator("JeS[");
		colName.add(new RequiredValidator());
		colName.add(new MaxLengthValidator(20));
		
		validator.addColumnValidator(colId);
		validator.addColumnValidator(colName);
	}

	/**
	 * JeS[DaoZbg܂B
	 * @param categoryDao JeS[Dao
	 */
	public void setCategoryDao(CategoryDao categoryDao) {
		this.categoryDao = categoryDao;
	}
	
	/** 
	 * C|[g 
	 * @param table ̓f[^
	 * @return C|[g
	 */
	public ImportResult importTable(DataTable table) {
		// 1.̓f[^̌
		ImportResult result = validateTable(table);
		if (result.hasError()) {
			return result;
		}
		// 2.OiȂj
		// 3.̓f[^̃JeS[C|[g鏈
		for (int i = 0; i < table.getRowSize(); i++) {
			try {
				DataRow row = table.getRow(i);
				Object id = row.getValue("id");
				// NOTE:IDȂΐVKǉA΍XV
				if (id == null || StringUtils.isEmpty(id.toString())) {
					Category category = new Category();
					category.setName((String)row.getValue("JeS["));
					categoryDao.insert(category);
				} else {
					Category category = categoryDao.findById(new Integer(id.toString()));
					category.setName((String)row.getValue("JeS["));
					categoryDao.update(category);
				}
			} catch (Exception e) {
				ImportError error = new ImportError(e.getMessage());
				result.addError(error);
			}
		}
		return result;
	}

	/**
	 * ̓f[^̌
	 * @param table ̓f[^
	 * @return C|[g
	 */
	public ImportResult validateTable(DataTable table) {
		ImportResult result = new ImportResult();
		// 1.̓f[^Ŝ̌
		if (table.getRowSize() == 0) {
			result.addError(new ImportError("C|[gf[^܂B"));
		}
		// 2.sƂ̌
		for (int i = 0; i < table.getRowSize(); i++) {
			DataRow row = table.getRow(i);
			String[] errors = validator.validate(row);
			int lineNum = i + LINE_NUM_OFFSET;
			for (String error : errors) {
				result.addError(new ImportError(error, lineNum));
			}
		}
		return result;
	}
}