package beautiful02.ex1;

import org.seasar.extension.dataset.DataRow;
import org.seasar.extension.dataset.DataTable;

import beautiful01.validator.ColumnValidator;
import beautiful01.validator.ContainsValidator;
import beautiful01.validator.DataRowValidator;
import beautiful01.validator.EMailValidator;
import beautiful01.validator.MaxLengthValidator;
import beautiful01.validator.NotEmptyCondition;
import beautiful01.validator.RequiredValidator;
import beautiful02.dao.UserDao;
import beautiful02.entity.User;

/**
 * [U}X^̃C|[g
 */
public class UserImportLogicImpl {
	/** sԍ̃ItZbglif[^͂QsڂJn邽߁j */
	public static final int LINE_NUM_OFFSET = 2;
	/** [UDao */
	private UserDao userDao;
	/** ͌؏NX */
	private DataRowValidator validator = new DataRowValidator();

	/**
	 * RXgN^
	 */
	public UserImportLogicImpl() {
		initialize();
	}

	/**
	 * F͌؂̃[ݒ 
	 */
	private void initialize() {
		ColumnValidator colName = new ColumnValidator("");
		colName.add(new RequiredValidator());
		colName.add(new MaxLengthValidator(20));

		ColumnValidator colType = new ColumnValidator("");
		colType.add(new RequiredValidator());
		colType.add(new ContainsValidator("0", "1"));
		
		ColumnValidator colMail = new ColumnValidator("[AhX");
		colMail.add(new NotEmptyCondition(new EMailValidator()));
		
		validator.addColumnValidator(colName);
		validator.addColumnValidator(colType);
		validator.addColumnValidator(colMail);
	}
	
	/**
	 * [UDaoZbg܂B
	 * @param userDao [UDao
	 */
	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}

	/** 
	 * C|[g 
	 * @param table ̓f[^
	 * @return C|[g
	 */
	public ImportResult importTable(DataTable table) {
		// 1.̓f[^̌
		ImportResult result = validateTable(table);
		if (result.hasError()) {
			return result;
		}
		// 2.OiSẴ[U폜j
		userDao.deleteAll();	
		// 3.̓f[^̃[UC|[g鏈
		for (int i = 0; i < table.getRowSize(); i++) {
			try {
				DataRow row = table.getRow(i);
				User user = new User();
				user.setName((String)row.getValue(""));
				user.setType(Integer.parseInt((String)row.getValue("")));
				user.setMailAddress((String)row.getValue("[AhX"));
				userDao.insert(user);
			} catch (Exception e) {
				ImportError error = new ImportError(e.getMessage());
				result.addError(error);
			}
		}
		return result;
	}

	/**
	 * ̓f[^̌
	 * @param table ̓f[^
	 * @return C|[g
	 */
	public ImportResult validateTable(DataTable table) {
		ImportResult result = new ImportResult();
		// 1.̓f[^Ŝ̌
		if (table.getRowSize() == 0) {
			result.addError(new ImportError("C|[gf[^܂B"));
		}
		// 2.sƂ̌
		for (int i = 0; i < table.getRowSize(); i++) {
			DataRow row = table.getRow(i);
			String[] errors = validator.validate(row);
			int lineNum = i + LINE_NUM_OFFSET;
			for (String error : errors) {
				result.addError(new ImportError(error, lineNum));
			}
		}
		return result;
	}
}