package beautiful02.ex3.impl;

import org.seasar.extension.dataset.DataRow;
import org.seasar.extension.dataset.DataTable;

import beautiful01.validator.ColumnValidator;
import beautiful01.validator.ContainsValidator;
import beautiful01.validator.EMailValidator;
import beautiful01.validator.MaxLengthValidator;
import beautiful01.validator.NotEmptyCondition;
import beautiful01.validator.RequiredValidator;
import beautiful02.dao.UserDao;
import beautiful02.entity.User;
import beautiful02.ex3.framework.AbstractImportLogic;
import beautiful02.ex3.framework.ImportResult;

/**
 * [U}X^̃C|[g
 */
public class UserImportLogicImpl extends AbstractImportLogic {
	/** [UDao */
	private UserDao userDao;

	/**
	 * RXgN^
	 */
	public UserImportLogicImpl() {
		initialize();
	}
	/**
	 * F͌؂̃[ݒ 
	 */
	private void initialize() {
		ColumnValidator colName = new ColumnValidator("");
		colName.add(new RequiredValidator());
		colName.add(new MaxLengthValidator(20));

		ColumnValidator colType = new ColumnValidator("");
		colType.add(new RequiredValidator());
		colType.add(new ContainsValidator("0", "1"));
		
		ColumnValidator colMail = new ColumnValidator("[AhX");
		colMail.add(new NotEmptyCondition(new EMailValidator()));
		
		addColumnValidator(colName);
		addColumnValidator(colType);
		addColumnValidator(colMail);
	}
	
	/**
	 * [UDaoZbg܂B
	 * @param userDao [UDao
	 */
	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}

	/**
	 * C|[gOB
	 * [USč폜܂B
	 */
	@Override
	protected void doPreImportProcess(DataTable table, ImportResult result) {
		userDao.deleteAll();
	}
	
	/**
	 * 1s̃C|[g
	 * @param row 1s̓̓f[^
	 * @param index 
	 */
	@Override
	protected void doImportRow(DataRow row, int index) {
		User user = new User();
		user.setName((String)row.getValue(""));
		user.setType(Integer.parseInt((String)row.getValue("")));
		user.setMailAddress((String)row.getValue("[AhX"));
		userDao.insert(user);
	}
}