package beautiful02.ex4;

import org.seasar.extension.dataset.DataTable;
import org.seasar.extension.dataset.impl.XlsReader;
import org.seasar.extension.unit.S2TestCase;

import beautiful02.ex4.framework.ImportResult;
import beautiful02.ex4.impl.CategoryImportLogicImpl;

public class CategoryImportLogicImplTest extends S2TestCase {

	CategoryImportLogicImpl categoryImportLogic;
	
	@Override
	protected void setUp() throws Exception {
		include("ex4.dicon");
		categoryImportLogic = (CategoryImportLogicImpl)getComponent("categoryImportLogic");
	}
	
	public void testValidateTableAndImportTable() throws Exception {
		XlsReader reader = new XlsReader(getClass().getResourceAsStream("/beautiful02/categories.xls"));
		DataTable table = reader.read().getTable("JeS[ꗗ");
		ImportResult result = categoryImportLogic.validateTable(table);
		assertEquals("G[", 0, result.getErrors().size());
		result = categoryImportLogic.importTable(table);
		assertEquals("G[", 0, result.getErrors().size());
	}

	public void testValidateTableAndImportTableHasErrors() throws Exception {
		XlsReader reader = new XlsReader(getClass().getResourceAsStream("/beautiful02/categories_hasErrors.xls"));
		DataTable table = reader.read().getTable("JeS[ꗗ");
		ImportResult result = categoryImportLogic.validateTable(table);
		assertEquals("G[", 1, result.getErrors().size());
		assertEquals("sԍ", new Integer(4), result.getErrors().get(0).getLineNumber());
		assertEquals("G[bZ[W", "JeS[͕K{łB", result.getErrors().get(0).getMessage());

		result = categoryImportLogic.importTable(table);
		assertEquals("G[", 1, result.getErrors().size());
		assertEquals("sԍ", new Integer(4), result.getErrors().get(0).getLineNumber());
		assertEquals("G[bZ[W", "JeS[͕K{łB", result.getErrors().get(0).getMessage());
	}
}
